## cri-o 1.19.6~0

=== debian/changelog ===
cri-o (1.19.6~0) stable; urgency=medium

  * bump to v1.19.6

cri-o (1.19.2~0) stable; urgency=medium

  * bump to v1.19.2

cri-o (1.19.1~0) stable; urgency=medium

  * bump to v1.19.1

cri-o (1.19.0~0) stable; urgency=medium

  * bump to v1.19.0

cri-o (1.18.3~2) stable; urgency=medium

  * allow build with custom Go binary 

 -- Lokesh Mandvekar <lsm5@fedoraproject.org>  Wed, 29 Jul 2020 11:12:35 +0000

cri-o (1.18.3~1) stable; urgency=medium

  * Non-maintainer upload.
  * bump to v1.18.3 

 -- Lokesh Mandvekar <lsm5@fedoraproject.org>  Wed, 29 Jul 2020 02:24:13 +0000

cri-o (1.18.2~1) stable; urgency=medium

  * built v1.18.2 - build 1.18.2

 -- Douglas Schilling Landgraf <dougsland@redhat.com>  Wed, 24 Jun 2020 08:39:00 +0000

cri-o (1.18.0~3) stable; urgency=medium

  * built v1.18.0 - previous build was not complete.

 -- Douglas Schilling Landgraf <dougsland@redhat.com>  Sun, 03 May 2020 08:39:00 +0000

cri-o (1.18.0~2) stable; urgency=medium

  * built v1.18.0

 -- Douglas Schilling Landgraf <dougsland@redhat.com>  Thu, 01 May 2020 13:34:00 +0000

cri-o (1.18.0~1) stable; urgency=medium

  * built v1.18.0-rc1

 -- Douglas Schilling Landgraf <dougsland@redhat.com>  Thu, 30 Apr 2020 13:34:00 +0000

cri-o-1.17 (1.17.3~1) stable; urgency=medium

  * autobuilt v1.17.3

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Fri, 10 Apr 2020 18:01:45 +0000

cri-o-1.17 (1.17.2~142) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 14:26:49 +0000

cri-o-1.17 (1.17.2~141) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 14:21:39 +0000

cri-o-1.17 (1.17.2~140) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 14:16:55 +0000

cri-o-1.17 (1.17.2~139) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 14:11:49 +0000

cri-o-1.17 (1.17.2~138) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 14:07:08 +0000

cri-o-1.17 (1.17.2~137) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 14:01:33 +0000

cri-o-1.17 (1.17.2~136) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:56:52 +0000

cri-o-1.17 (1.17.2~135) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:51:58 +0000

cri-o-1.17 (1.17.2~134) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:46:53 +0000

cri-o-1.17 (1.17.2~133) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:41:34 +0000

cri-o-1.17 (1.17.2~132) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:36:48 +0000

cri-o-1.17 (1.17.2~131) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:31:42 +0000

cri-o-1.17 (1.17.2~130) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:26:50 +0000

cri-o-1.17 (1.17.2~129) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:21:43 +0000

cri-o-1.17 (1.17.2~128) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:16:41 +0000

cri-o-1.17 (1.17.2~127) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:11:45 +0000

cri-o-1.17 (1.17.2~126) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:07:11 +0000

cri-o-1.17 (1.17.2~125) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 13:02:03 +0000

cri-o-1.17 (1.17.2~124) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:56:39 +0000

cri-o-1.17 (1.17.2~123) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:51:56 +0000

cri-o-1.17 (1.17.2~122) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:47:09 +0000

cri-o-1.17 (1.17.2~121) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:41:34 +0000

cri-o-1.17 (1.17.2~120) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:36:57 +0000

cri-o-1.17 (1.17.2~119) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:31:48 +0000

cri-o-1.17 (1.17.2~118) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:26:47 +0000

cri-o-1.17 (1.17.2~117) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:21:43 +0000

cri-o-1.17 (1.17.2~116) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:16:46 +0000

cri-o-1.17 (1.17.2~115) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:11:55 +0000

cri-o-1.17 (1.17.2~114) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:07:45 +0000

cri-o-1.17 (1.17.2~113) stable; urgency=medium

  * autobuilt

 -- RH Container Bot <rhcontainerbot@fedoraproject.org>  Wed, 01 Apr 2020 12:01:42 +0000



=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
DH_GOPKG := github.com/cri-o/cri-o
BUILDDIR := $(shell pwd)
DESTDIR := $(BUILDDIR)/debian/cri-o
PREFIX := /usr
BINDIR := $(DESTDIR)$(PREFIX)/bin
UNITDIR := $(DESTDIR)$(PREFIX)/lib/systemd/system
SYSCONFDIR := $(DESTDIR)/etc/default
BUILDTAGS := 'apparmor seccomp containers_image_ostree_stub exclude_graphdriver_btrfs exclude_graphdriver_devicemapper'
GO_MD2MAN := /usr/bin/go-md2man

define CRIO_CONF_OVERRIDE
[crio.runtime.runtimes.runc]
runtime_path = "/usr/lib/cri-o-runc/sbin/runc"
runtime_type = "oci"
runtime_root = "/run/runc"
endef
export CRIO_CONF_OVERRIDE

ifneq (,$(wildcard /usr/lib/go-1.15/bin/go))
        GO_BINARY := /usr/lib/go-1.15/bin/go
else ifneq (,$(wildcard /usr/lib/go-1.14/bin/go))
        GO_BINARY := /usr/lib/go-1.14/bin/go
else
        GO_BINARY := /usr/bin/go
endif
GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
GO_BUILD := "$(GO) build"
UPSTREAM_TAG=v1.19.6

%:
	dh_clean
	make clean
	rm -rf $(BUILDDIR)/obj-*-linux-gnu $(BUILDDIR)/debian/cri-o/*
	rm -rf $(BUILDDIR)/src $(BUILDDIR)/crio.conf $(BUILDDIR)/pkg/linux_*
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_configure:
	# Include vendored dependencies.
	cp -rp $(BUILDDIR)/vendor $(BUILDDIR)/src
	ln -s $(BUILDDIR) $(BUILDDIR)/src/$(DH_GOPKG)

override_dh_auto_build:
	make \
	   GOPATH=$(BUILDDIR) \
	   GO_BUILD=$(GO_BUILD) \
	   BUILDTAGS=$(BUILDTAGS) \
	   PROJECT=$(DH_GOPKG) \
	   binaries docs

override_dh_auto_test:

override_dh_auto_install:
	make \
	   PREFIX=$(DESTDIR)/usr \
	   CRICTL_CONFIG_DIR=$(DESTDIR)/etc \
	   ETCDIR_CRIO=$(DESTDIR)/etc/crio \
	   GO_MD2MAN=$(GO_MD2MAN) \
	   GOPATH=$(BUILDDIR) \
	   GO_BUILD=$(GO_BUILD) \
	   CRICTL_CONFIG_DIR=$(DESTDIR)/etc \
	   install.bin-nobuild \
	   install.completions \
	   install.config \
	   install.man-nobuild \
	   install.systemd
	# install binaries
	install -dp $(DESTDIR)/etc/cni/net.d
	install -p -m 644 contrib/cni/10-crio-bridge.conf $(DESTDIR)/etc/cni/net.d/100-crio-bridge.conf
	install -p -m 644 contrib/cni/99-loopback.conf $(DESTDIR)/etc/cni/net.d/200-loopback.conf
	install -dp $(SYSCONFDIR)
	install -p -m 644 contrib/sysconfig/crio $(SYSCONFDIR)
	# install override file
	echo "$$CRIO_CONF_OVERRIDE" >$(DESTDIR)/etc/crio/crio.conf.d/01-crio-runc.conf
	# changes to unit and config files
	sed -i 's/sysconfig/default/g' $(SYSCONFDIR)/crio
	sed -i 's/sysconfig/default/g' $(UNITDIR)/crio.service
	sed -i 's/sysconfig/default/g' $(UNITDIR)/crio-wipe.service
	sed -i 's/\/usr\/local/\/usr/g' $(UNITDIR)/crio.service
	sed -i 's/\/usr\/local/\/usr/g' $(UNITDIR)/crio-wipe.service

override_dh_golang:

## cri-o 1.22.5~1

=== Makefile ===
GO ?= go

export GOPROXY=https://proxy.golang.org
export GOSUMDB=https://sum.golang.org

TRIMPATH ?= -trimpath
GO_BUILD ?= $(GO) build $(TRIMPATH)
GO_RUN ?= $(GO) run

PROJECT := github.com/cri-o/cri-o
CRIO_INSTANCE := crio_dev
PREFIX ?= ${DESTDIR}/usr/local
BINDIR ?= ${PREFIX}/bin
LIBEXECDIR ?= ${PREFIX}/libexec
MANDIR ?= ${PREFIX}/share/man
ETCDIR ?= ${DESTDIR}/etc
ETCDIR_CRIO ?= ${ETCDIR}/crio
DATAROOTDIR ?= ${PREFIX}/share/containers
BUILDTAGS ?= containers_image_ostree_stub \
			 $(shell hack/apparmor_tag.sh) \
			 $(shell hack/btrfs_installed_tag.sh) \
			 $(shell hack/btrfs_tag.sh) \
			 $(shell hack/libdm_installed.sh) \
			 $(shell hack/libdm_no_deferred_remove_tag.sh) \
			 $(shell hack/openpgp_tag.sh) \
			 $(shell hack/seccomp_tag.sh) \
			 $(shell hack/selinux_tag.sh) \
			 $(shell hack/libsubid_tag.sh)
CRICTL_CONFIG_DIR=${DESTDIR}/etc
CONTAINER_RUNTIME ?= podman
BUILD_PATH := $(shell pwd)/build
BUILD_BIN_PATH := ${BUILD_PATH}/bin
COVERAGE_PATH := ${BUILD_PATH}/coverage
JUNIT_PATH := ${BUILD_PATH}/junit
TESTBIN_PATH := ${BUILD_PATH}/test
MOCK_PATH := ${PWD}/test/mocks

BASHINSTALLDIR=${PREFIX}/share/bash-completion/completions
FISHINSTALLDIR=${PREFIX}/share/fish/completions
ZSHINSTALLDIR=${PREFIX}/share/zsh/site-functions
OCIUMOUNTINSTALLDIR=$(PREFIX)/share/oci-umount/oci-umount.d

SELINUXOPT ?= $(shell selinuxenabled 2>/dev/null && echo -Z)

SOURCE_DATE_EPOCH ?= $(shell date +%s)

GO_MD2MAN ?= ${BUILD_BIN_PATH}/go-md2man
GINKGO := ${BUILD_BIN_PATH}/ginkgo
MOCKGEN := ${BUILD_BIN_PATH}/mockgen
GOLANGCI_LINT := ${BUILD_BIN_PATH}/golangci-lint
GO_MOD_OUTDATED := ${BUILD_BIN_PATH}/go-mod-outdated
RELEASE_NOTES := ${BUILD_BIN_PATH}/release-notes
ZEITGEIST := ${BUILD_BIN_PATH}/zeitgeist
SHFMT := ${BUILD_BIN_PATH}/shfmt
SHELLCHECK := ${BUILD_BIN_PATH}/shellcheck
BATS_FILES := $(wildcard test/*.bats)

ifeq ($(shell bash -c '[[ `command -v git` && `git rev-parse --git-dir 2>/dev/null` ]] && echo true'), true)
	COMMIT_NO := $(shell git rev-parse HEAD 2> /dev/null || true)
	GIT_TREE_STATE := $(if $(shell git status --porcelain --untracked-files=no),dirty,clean)
else
	COMMIT_NO := unknown
	GIT_TREE_STATE := unknown
endif

# pass crio CLI options to generate custom configuration options at build time
CONF_OVERRIDES ?=

CROSS_BUILD_TARGETS := \
	bin/crio.cross.windows.amd64 \
	bin/crio.cross.darwin.amd64 \
	bin/crio.cross.linux.amd64

# If GOPATH not specified, use one in the local directory
ifeq ($(GOPATH),)
export GOPATH := $(CURDIR)/_output
unexport GOBIN
endif
GOPKGDIR := $(GOPATH)/src/$(PROJECT)
GOPKGBASEDIR := $(shell dirname "$(GOPKGDIR)")
GO_FILES := $(shell find . -type f -name '*.go' -not -name '*_test.go')

# Update VPATH so make finds .gopathok
VPATH := $(VPATH):$(GOPATH)

# Set DEBUG=1 to enable debug symbols in binaries
DEBUG ?= 0
ifeq ($(DEBUG),0)
SHRINKFLAGS = -s -w
else
GCFLAGS = -gcflags '-N -l'
endif

DEFAULTS_PATH := ""

DATE_FMT = +'%Y-%m-%dT%H:%M:%SZ'
ifdef SOURCE_DATE_EPOCH
    BUILD_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "$(DATE_FMT)" 2>/dev/null || date -u "$(DATE_FMT)")
else
    BUILD_DATE ?= $(shell date -u "$(DATE_FMT)")
endif

BASE_LDFLAGS = ${SHRINKFLAGS} \
	-X ${PROJECT}/internal/pkg/criocli.DefaultsPath=${DEFAULTS_PATH} \
	-X ${PROJECT}/internal/version.buildDate=${BUILD_DATE} \
	-X ${PROJECT}/internal/version.gitCommit=${COMMIT_NO} \
	-X ${PROJECT}/internal/version.gitTreeState=${GIT_TREE_STATE}

GO_LDFLAGS = -ldflags '${BASE_LDFLAGS} ${EXTRA_LDFLAGS}'

all: binaries crio.conf docs

default: help

help:
	@echo "Usage: make <target>"
	@echo
	@echo " * 'install' - Install binaries to system locations"
	@echo " * 'binaries' - Build crio and pinns"
	@echo " * 'release-note' - Generate release note"
	@echo " * 'localintegration' - Execute integration tests"
	@echo " * 'clean' - Clean artifacts"
	@echo " * 'lint' - Execute the source code linter"
	@echo " * 'shfmt' - shell format check and apply diff"
	@echo " * 'shellcheck' - Execute the shellcheck linter"

# Dummy target for marking pattern rules phony
.explicit_phony:

.gopathok:
ifeq ("$(wildcard $(GOPKGDIR))","")
	mkdir -p "$(GOPKGBASEDIR)"
	ln -s "$(CURDIR)" "$(GOPKGDIR)"
endif
	touch "$(GOPATH)/.gopathok"

# See also: .github/workflows/lint.yml
lint: .gopathok ${GOLANGCI_LINT}
	${GOLANGCI_LINT} version
	${GOLANGCI_LINT} linters
	${GOLANGCI_LINT} run

check-log-lines:
	./hack/log-capitalized.sh
	./hack/tree_status.sh

shellfiles: ${SHFMT}
	$(eval SHELLFILES=$(shell ${SHFMT} -f . | grep -v vendor/ | grep -v hack/lib | grep -v hack/build-rpms.sh))

shfmt: shellfiles
	${SHFMT} -ln bash -w -i 4 -d ${SHELLFILES}
	${SHFMT} -ln bats -w -sr -d $(BATS_FILES)

shellcheck: shellfiles ${SHELLCHECK}
	${SHELLCHECK} \
		-P contrib/bundle \
		-P scripts \
		-P test \
		-x \
		${SHELLFILES} ${BATS_FILES}

bin/pinns:
	$(MAKE) -C pinns

test/copyimg/copyimg: $(GO_FILES) .gopathok
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/test/copyimg

test/checkseccomp/checkseccomp: $(GO_FILES) .gopathok
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/test/checkseccomp

bin/crio: $(GO_FILES) .gopathok
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/cmd/crio

bin/crio-status: $(GO_FILES) .gopathok
	$(GO_BUILD) $(GCFLAGS) $(GO_LDFLAGS) -tags "$(BUILDTAGS)" -o $@ $(PROJECT)/cmd/crio-status

build-static:
	$(CONTAINER_RUNTIME) run --rm --privileged -ti -v /:/mnt \
		nixos/nix cp -rfT /nix /mnt/nix
	$(CONTAINER_RUNTIME) run --rm --privileged -ti -v /nix:/nix -v ${PWD}:${PWD} -w ${PWD} \
		nixos/nix nix --print-build-logs --option cores 8 --option max-jobs 8 build --file nix/
	mkdir -p bin
	cp -r result/bin bin/static

release-bundle: clean bin/pinns build-static docs crio.conf bundle

crio.conf: bin/crio
	./bin/crio -d "" --config="" $(CONF_OVERRIDES) config > crio.conf

release:
	${GO_RUN} ./scripts/release

release-notes: ${RELEASE_NOTES}
	${GO_RUN} ./scripts/release-notes \
		--output-path ${BUILD_PATH}/release-notes

dependencies: ${GO_MOD_OUTDATED}
	${GO_RUN} ./scripts/dependencies \
		--output-path ${BUILD_PATH}/dependencies

clean:
ifneq ($(GOPATH),)
	rm -f "$(GOPATH)/.gopathok"
endif
	rm -rf _output
	rm -f docs/*.5 docs/*.8
	rm -fr test/testdata/redis-image
	find . -name \*~ -delete
	find . -name \#\* -delete
	rm -rf bin/
	$(MAKE) -C pinns clean
	rm -f test/copyimg/copyimg
	rm -f test/checkseccomp/checkseccomp
	rm -rf ${BUILD_BIN_PATH}

# the approach here, rather than this target depending on the build targets
# directly, is such that each target should try to build regardless if it
# fails. And return a non-zero exit if _any_ target fails.
local-cross:
	@$(MAKE) --keep-going $(CROSS_BUILD_TARGETS)

bin/crio.cross.%: .gopathok .explicit_phony
	@echo "==> make $@"; \
	TARGET="$*"; \
	GOOS="$${TARGET%%.*}" \
	GOARCH="$${TARGET##*.}" \
	$(GO_BUILD) $(GO_LDFLAGS) -tags "containers_image_openpgp btrfs_noversion" -o "$@" $(PROJECT)/cmd/crio

nixpkgs:
	@nix run -f channel:nixpkgs-unstable nix-prefetch-git -c nix-prefetch-git \
		--no-deepClone https://github.com/nixos/nixpkgs > nix/nixpkgs.json


define go-build
	$(shell cd `pwd` && $(GO_BUILD) -o $(BUILD_BIN_PATH)/$(shell basename $(1)) $(1))
	@echo > /dev/null
endef

${GO_MD2MAN}:
	$(call go-build,./vendor/github.com/cpuguy83/go-md2man)

${GINKGO}:
	$(call go-build,./vendor/github.com/onsi/ginkgo/ginkgo)

${MOCKGEN}:
	$(call go-build,./vendor/github.com/golang/mock/mockgen)

${RELEASE_NOTES}:
	$(call go-build,./vendor/k8s.io/release/cmd/release-notes)

${SHFMT}:
	$(call go-build,./vendor/mvdan.cc/sh/v3/cmd/shfmt)

${GO_MOD_OUTDATED}:
	$(call go-build,./vendor/github.com/psampaz/go-mod-outdated)

${ZEITGEIST}:
	$(call go-build,./vendor/sigs.k8s.io/zeitgeist)

${GOLANGCI_LINT}:
	export VERSION=v1.40.1 \
		URL=https://raw.githubusercontent.com/golangci/golangci-lint \
		BINDIR=${BUILD_BIN_PATH} && \
	curl -sSfL $$URL/$$VERSION/install.sh | sh -s $$VERSION

${SHELLCHECK}:
	mkdir -p ${BUILD_BIN_PATH} && \
	VERSION=v0.7.0 \
	URL=https://github.com/koalaman/shellcheck/releases/download/$$VERSION/shellcheck-$$VERSION.linux.x86_64.tar.xz \
	SHA256SUM=c37d4f51e26ec8ab96b03d84af8c050548d7288a47f755ffb57706c6c458e027 && \
	curl -sSfL $$URL | tar xfJ - -C ${BUILD_BIN_PATH} --strip 1 shellcheck-$$VERSION/shellcheck && \
	sha256sum ${SHELLCHECK} | grep -q $$SHA256SUM

vendor: export GOSUMDB :=
vendor:
	$(GO) mod tidy
	$(GO) mod vendor
	$(GO) mod verify

check-vendor: vendor
	./hack/tree_status.sh

testunit: ${GINKGO}
	rm -rf ${COVERAGE_PATH} && mkdir -p ${COVERAGE_PATH}
	rm -rf ${JUNIT_PATH} && mkdir -p ${JUNIT_PATH}
	ACK_GINKGO_DEPRECATIONS=1.16.0 \
	${BUILD_BIN_PATH}/ginkgo \
		${TESTFLAGS} \
		-r \
		--trace \
		--cover \
		--covermode atomic \
		--outputdir ${COVERAGE_PATH} \
		--coverprofile coverprofile \
		--tags "test $(BUILDTAGS)" \
		$(GO_MOD_VENDOR) \
		--succinct
	$(GO) tool cover -html=${COVERAGE_PATH}/coverprofile -o ${COVERAGE_PATH}/coverage.html
	$(GO) tool cover -func=${COVERAGE_PATH}/coverprofile | sed -n 's/\(total:\).*\([0-9][0-9].[0-9]\)/\1 \2/p'
	for f in $$(find . -name "*_junit.xml"); do \
		mkdir -p $(JUNIT_PATH)/$$(dirname $$f) ;\
		mv $$f $(JUNIT_PATH)/$$(dirname $$f) ;\
	done

testunit-bin:
	mkdir -p ${TESTBIN_PATH}
	for PACKAGE in `$(GO) list ./...`; do \
		go test $$PACKAGE \
			--tags "test $(BUILDTAGS)" \
			--gcflags '-N' -c -o ${TESTBIN_PATH}/$$(basename $$PACKAGE) ;\
	done

mockgen: \
	mock-cmdrunner \
	mock-containerstorage \
	mock-criostorage \
	mock-lib-config \
	mock-oci \
	mock-image-types \
	mock-ocicni-types

mock-containerstorage: ${MOCKGEN}
	${MOCKGEN} \
		-package containerstoragemock \
		-destination ${MOCK_PATH}/containerstorage/containerstorage.go \
		github.com/containers/storage Store

mock-cmdrunner: ${MOCKGEN}
	${MOCKGEN} \
		-package cmdrunnermock \
		-destination ${MOCK_PATH}/cmdrunner/cmdrunner.go \
		github.com/cri-o/cri-o/utils/cmdrunner CommandRunner

mock-criostorage: ${MOCKGEN}
	${MOCKGEN} \
		-package criostoragemock \
		-destination ${MOCK_PATH}/criostorage/criostorage.go \
		github.com/cri-o/cri-o/internal/storage ImageServer,RuntimeServer

mock-lib-config: ${MOCKGEN}
	${MOCKGEN} \
		-package libconfigmock \
		-destination ${MOCK_PATH}/lib/lib.go \
		github.com/cri-o/cri-o/pkg/config Iface

mock-oci: ${MOCKGEN}
	${MOCKGEN} \
		-package ocimock \
		-destination ${MOCK_PATH}/oci/oci.go \
		github.com/cri-o/cri-o/internal/oci RuntimeImpl

mock-image-types: ${MOCKGEN}
	${BUILD_BIN_PATH}/mockgen \
		-package imagetypesmock \
		-destination ${MOCK_PATH}/containers/image/v5/types.go \
		github.com/containers/image/v5/types ImageCloser

mock-ocicni-types: ${MOCKGEN}
	${BUILD_BIN_PATH}/mockgen \
		-package ocicnitypesmock \
		-destination ${MOCK_PATH}/ocicni/types.go \
		github.com/cri-o/ocicni/pkg/ocicni CNIPlugin

codecov: SHELL := $(shell which bash)
codecov:
	bash <(curl -s https://codecov.io/bash) -f ${COVERAGE_PATH}/coverprofile

localintegration: clean binaries test-binaries
	./test/test_runner.sh ${TESTFLAGS}

binaries: bin/crio bin/crio-status bin/pinns
test-binaries: test/copyimg/copyimg test/checkseccomp/checkseccomp

MANPAGES_MD := $(wildcard docs/*.md)
MANPAGES    := $(MANPAGES_MD:%.md=%)

docs/%.5: docs/%.5.md .gopathok ${GO_MD2MAN}
	(${GO_MD2MAN} -in $< -out $@.tmp && touch $@.tmp && mv $@.tmp $@) || \
		(${GO_MD2MAN} -in $< -out $@.tmp && touch $@.tmp && mv $@.tmp $@)

docs/%.8: docs/%.8.md .gopathok ${GO_MD2MAN}
	(${GO_MD2MAN} -in $< -out $@.tmp && touch $@.tmp && mv $@.tmp $@) || \
		(${GO_MD2MAN} -in $< -out $@.tmp && touch $@.tmp && mv $@.tmp $@)

completions-generation:
	bin/crio complete bash > completions/bash/crio
	bin/crio complete fish > completions/fish/crio.fish
	bin/crio complete zsh  > completions/zsh/_crio
	bin/crio-status complete bash > completions/bash/crio-status
	bin/crio-status complete fish > completions/fish/crio-status.fish
	bin/crio-status complete zsh  > completions/zsh/_crio-status

docs: $(MANPAGES)

docs-generation:

=== pinns/Makefile ===
src = $(wildcard src/*.c)
obj = $(src:.c=.o)

STRIP ?= strip
override LIBS +=
CFLAGS ?= -std=c99 -Os -Wall -Werror -Wextra -static

all: ../bin/pinns

../bin/pinns: $(obj) | ../bin
	$(CC) -o $@ $^ $(CFLAGS) $(LIBS)
	$(STRIP) -s $@

%.o: %.c $(HEADERS)
	$(CC) $(CFLAGS) -O3 -o $@ -c $<

../bin:
	mkdir -p $@

.PHONY: clean
clean:
	rm -f $(obj) ../bin/pinns

=== contrib/bundle/Makefile ===
all:
	./install

=== vendor/sigs.k8s.io/zeitgeist/Makefile ===
# Copyright 2021 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# If you update this file, please follow
# https://suva.sh/posts/well-documented-makefiles

.DEFAULT_GOAL:=help
SHELL:=/usr/bin/env bash

COLOR:=\\033[36m
NOCOLOR:=\\033[0m

build: ## Build zeitgeist
	go build

lint:
	test -z $(shell go fmt .) || (echo "Linting failed !" && exit 8)
	go vet ./...
	go get -u golang.org/x/lint/golint
	golint ./...

test: ## Runs unit testing
	go test ./... -covermode=count -coverprofile=coverage.out

test-results: test
	go tool cover -html=coverage.out

verify: verify-boilerplate verify-golangci-lint verify-go-mod  ## Runs verification scripts to ensure correct execution

verify-boilerplate: ## Runs the file header check
	./hack/verify-boilerplate.sh

verify-go-mod: ## Runs the go module linter
	./hack/verify-go-mod.sh

verify-golangci-lint: ## Runs all golang linters
	./hack/verify-golangci-lint.sh

##@ Helpers

.PHONY: help

help:  ## Display this help
	@awk \
		-v "col=${COLOR}" -v "nocol=${NOCOLOR}" \
		' \
			BEGIN { \
				FS = ":.*##" ; \
				printf "\nUsage:\n  make %s<target>%s\n", col, nocol \
			} \
			/^[a-zA-Z_-]+:.*?##/ { \
				printf "  %s%-15s%s %s\n", col, $$1, nocol, $$2 \
			} \
			/^##@/ { \
				printf "\n%s%s%s\n", col, substr($$0, 5), nocol \
			} \
		' $(MAKEFILE_LIST)

## cri-o 1.20.0~0

=== debian/changelog ===
cri-o (1.20.0~0) stable; urgency=medium

  * bump to v1.20.0

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 12 Mar 2021 02:24:13 +0000

=== debian/control ===
Source: cri-o
Section: devel
Priority: optional
Maintainer: Douglas Schilling Landgraf <dougsland@redhat.com>
Build-Depends: debhelper (>=9),
    rsync,
    libgpgme11-dev,
    libseccomp-dev,
    golang-1.15 | golang-1.14,
    libglib2.0-dev,
    go-md2man,
    dh-golang,
    git
Standards-Version: 4.3.0
Homepage: https://github.com/cri-o/cri-o
Vcs-Git: https://gitlab.com/rhcontainerbot/cri-o
Vcs-Browser: https://gitlab.com/rhcontainerbot/cri-o

Package: cri-o
Architecture: any
Depends: ${misc:Depends},
    libgpgme11,
    libseccomp2,
    conmon,
    containers-common (>=0.1.27),
    runc | cri-o-runc (>=1.0.0),
Suggests: containernetworking-plugins
Description: OCI-based implementation of Kubernetes Container Runtime Interface.
Replaces: cri-o-1.17,
   cri-o-1.16,
   cri-o-1.15,
   cri-o-1.14,
   cri-o-1.13,
   cri-o-1.12,
   cri-o-1.11,
   cri-o-1.11-stable,
   cri-o-1.10

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.19.6
+UPSTREAM_TAG=v1.20.0
 
 %:
 	dh_clean

## cri-o 1.20.1~0

=== debian/changelog ===
cri-o (1.20.1~0) stable; urgency=medium

  * bump to v1.20.1

=== debian/control ===
--- 
+++ 
@@ -23,8 +23,8 @@
     libseccomp2,
     conmon,
     containers-common (>=0.1.27),
-    runc | cri-o-runc (>=1.0.0),
-Suggests: containernetworking-plugins
+Suggests: cri-o-runc | runc (>=1.0.0),
+    containernetworking-plugins,
 Description: OCI-based implementation of Kubernetes Container Runtime Interface.
 Replaces: cri-o-1.17,
    cri-o-1.16,

## cri-o 1.20.2~0

=== debian/changelog ===
cri-o (1.20.2~0) stable; urgency=medium

  * bump to v1.20.2

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.20.0
+UPSTREAM_TAG=v1.20.2
 
 %:
 	dh_clean

## cri-o 1.20.5~0

=== debian/changelog ===
cri-o (1.20.5~0) stable; urgency=medium

  * bump to v1.20.5 

 -- Peter Hunt <haircommander@fedoraproject.org>  Thu, 16 Sep 2021 16:56:00 -0400

cri-o (1.20.3~0) stable; urgency=medium

  * bump to v1.20.3

=== debian/control ===
--- 
+++ 
@@ -23,6 +23,7 @@
     libseccomp2,
     conmon,
     containers-common (>=0.1.27),
+    tzdata,
 Suggests: cri-o-runc | runc (>=1.0.0),
     containernetworking-plugins,
 Description: OCI-based implementation of Kubernetes Container Runtime Interface.

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.20.2
+UPSTREAM_TAG=v1.20.5
 
 %:
 	dh_clean

## cri-o 1.20.7~0

=== debian/changelog ===
cri-o (1.20.7~0) stable; urgency=medium

  * bump to v1.20.7

cri-o (1.20.6~0) stable; urgency=medium

  * bump to v1.20.6

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.20.5
+UPSTREAM_TAG=v1.20.7
 
 %:
 	dh_clean

## cri-o 1.21.7~1

=== debian/changelog ===
cri-o (1.21.7~1) stable; urgency=medium

  * rebuild to fix gpg key

 -- Peter Hunt <pehunt@redhat.com>  Thu, 08 Dec 2022 14:47:24 -0500

cri-o (1.21.4~1) stable; urgency=medium

  * update v1.21.4

cri-o (1.21.4~0) stable; urgency=medium

  * bump to v1.21.4

cri-o (1.21.1~0) stable; urgency=medium

  * bump to v1.21.1

cri-o (1.21.0~0) stable; urgency=medium

  * bump to v1.21.0

=== debian/rules ===
--- 
+++ 
@@ -28,7 +28,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.20.7
+UPSTREAM_TAG=v1.21.7
 
 %:
 	dh_clean

## cri-o 1.22.1~1

=== debian/changelog ===
cri-o (1.22.1~1) stable; urgency=medium

  * update 1.22.1

cri-o (1.22.1~0) stable; urgency=medium

  * bump to v1.22.1

cri-o (1.22.0~0) stable; urgency=medium

  *  Bump to v1.22.0

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 17 Sep 2021 15:31:48 -0400

=== debian/rules ===
--- 
+++ 
@@ -19,16 +19,14 @@
 endef
 export CRIO_CONF_OVERRIDE
 
-ifneq (,$(wildcard /usr/lib/go-1.15/bin/go))
-        GO_BINARY := /usr/lib/go-1.15/bin/go
-else ifneq (,$(wildcard /usr/lib/go-1.14/bin/go))
-        GO_BINARY := /usr/lib/go-1.14/bin/go
+ifneq (,$(wildcard /usr/lib/go-1.16/bin/go))
+        GO_BINARY := /usr/lib/go-1.16/bin/go
 else
         GO_BINARY := /usr/bin/go
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.21.7
+UPSTREAM_TAG=v1.22.1
 
 %:
 	dh_clean

## cri-o 1.22.5~1

=== debian/changelog ===
cri-o (1.22.5~1) stable; urgency=medium

  * rebuild to fix gpg key

 -- Peter Hunt <haircommander@fedoraproject.org>  Thu, 08 Dec 2022 14:11:55 -0500

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: cri-o
 Section: devel
 Priority: optional
-Maintainer: Douglas Schilling Landgraf <dougsland@redhat.com>
+Maintainer: Peter Hunt <haircommander@fedoraproject.org>
 Build-Depends: debhelper (>=9),
     rsync,
     libgpgme11-dev,
     libseccomp-dev,
-    golang-1.15 | golang-1.14,
+    golang-1.16 | golang-1.16-go,
     libglib2.0-dev,
     go-md2man,
     dh-golang,
@@ -27,12 +27,6 @@
 Suggests: cri-o-runc | runc (>=1.0.0),
     containernetworking-plugins,
 Description: OCI-based implementation of Kubernetes Container Runtime Interface.
-Replaces: cri-o-1.17,
-   cri-o-1.16,
-   cri-o-1.15,
-   cri-o-1.14,
-   cri-o-1.13,
-   cri-o-1.12,
-   cri-o-1.11,
-   cri-o-1.11-stable,
-   cri-o-1.10
+Replaces: cri-o-1.21,
+   cri-o-1.20,
+   cri-o-1.19,

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.22.1
+UPSTREAM_TAG=v1.22.5
 
 %:
 	dh_clean

## cri-o 1.24.1~0

=== debian/changelog ===
cri-o (1.24.1~0) stable; urgency=medium

  * bump to v1.24.1

 -- Peter Hunt <haircommander@fedoraproject.org>  Mon, 06 Jun 2022 14:58:42 -0400

cri-o (1.24.0~2) stable; urgency=medium

  * use newer golang

 -- Peter Hunt <haircommander@fedoraproject.org>  Mon, 23 May 2022 16:59:15 -0400

cri-o (1.24.0~1) stable; urgency=medium

  * use distro containers-common

 -- Peter Hunt <haircommander@fedoraproject.org>  Mon, 23 May 2022 15:59:15 -0400

cri-o (1.24.0~0) stable; urgency=medium

  * bump to v1.24.0

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 13 May 2022 11:36:29 -0400

cri-o (1.23.2~1) stable; urgency=medium

  * bump version

cri-o (1.23.2~0) stable; urgency=medium

  * bump to v1.23.2

cri-o (1.23.1~0) stable; urgency=medium

  * bump to v1.23.1

cri-o (1.23.0~0) stable; urgency=medium

  * bump to v1.23.0

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
     rsync,
     libgpgme11-dev,
     libseccomp-dev,
-    golang-1.16 | golang-1.16-go,
+    golang-1.18 | golang-1.18-go,
     libglib2.0-dev,
     go-md2man,
     dh-golang,
@@ -22,7 +22,7 @@
     libgpgme11,
     libseccomp2,
     conmon,
-    containers-common (>=0.1.27),
+    containers-common (>=0.1.27) | golang-github-containers-common,
     tzdata,
 Suggests: cri-o-runc | runc (>=1.0.0),
     containernetworking-plugins,

=== debian/rules ===
--- 
+++ 
@@ -19,14 +19,14 @@
 endef
 export CRIO_CONF_OVERRIDE
 
-ifneq (,$(wildcard /usr/lib/go-1.16/bin/go))
-        GO_BINARY := /usr/lib/go-1.16/bin/go
+ifneq (,$(wildcard /usr/lib/go-1.18/bin/go))
+        GO_BINARY := /usr/lib/go-1.18/bin/go
 else
         GO_BINARY := /usr/bin/go
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.22.5
+UPSTREAM_TAG=v1.24.1
 
 %:
 	dh_clean

## cri-o 1.24.6~0

=== debian/changelog ===
cri-o (1.24.6~0) stable; urgency=medium

  * bump to v1.24.6

 -- Peter Hunt <haircommander@fedoraproject.org>  Wed, 14 Jun 2023 10:44:50 -0400

cri-o (1.24.5~0) stable; urgency=medium

  * bump to v1.24.5

 -- Peter Hunt <haircommander@fedoraproject.org>  Tue, 04 Apr 2023 10:31:22 -0400

cri-o (1.24.4~0) stable; urgency=medium

  * bump to v1.24.4

 -- Peter Hunt <haircommander@fedoraproject.org>  Tue, 10 Jan 2023 11:48:20 -0500

cri-o (1.24.3~1) stable; urgency=medium

  * rebuild to fix gpg key

 -- Peter Hunt <haircommander@fedoraproject.org>  Thu, 08 Dec 2022 13:45:48 -0500

cri-o (1.24.3~0) stable; urgency=medium

  * bump to v1.24.3

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 07 Oct 2022 14:15:22 -0400

cri-o (1.24.2~0) stable; urgency=medium

  * bump to v1.24.2

 -- Peter Hunt <haircommander@fedoraproject.org>  Tue, 09 Aug 2022 12:42:39 -0400

=== debian/rules ===
--- 
+++ 
@@ -26,7 +26,7 @@
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.24.1
+UPSTREAM_TAG=v1.24.6
 
 %:
 	dh_clean

## cri-o 1.25.0~0

=== debian/changelog ===
cri-o (1.25.0~0) stable; urgency=medium

  * bump to v1.25.0

 -- Peter Hunt <haircommander@fedoraproject.org>  Wed, 11 Jan 2023 15:33:58 -0500

cri-o (1.25.2~0) stable; urgency=medium

  * bump to v1.25.2

 -- Peter Hunt <haircommander@fedoraproject.org>  Tue, 10 Jan 2023 11:39:58 -0500

cri-o (1.25.1~2) stable; urgency=medium

  * rebuild to fix gpg key

 -- Peter Hunt <haircommander@fedoraproject.org>  Thu, 08 Dec 2022 13:23:29 -0500

cri-o (1.25.1~1) stable; urgency=medium

  * add c/image tag for debian 10

 -- Peter Hunt <haircommander@fedoraproject.org>  Tue, 15 Nov 2022 12:27:11 -0500

cri-o (1.25.1~0) stable; urgency=medium

  * bump to v1.25.1

 -- Peter Hunt <haircommander@fedoraproject.org>  Fri, 07 Oct 2022 13:35:02 -0400

cri-o (1.25.0~1) stable; urgency=medium

  * use golang 1.19

 -- Peter Hunt <haircommander@fedoraproject.org>  Mon, 29 Aug 2022 15:48:32 -0400

=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,7 @@
 BINDIR := $(DESTDIR)$(PREFIX)/bin
 UNITDIR := $(DESTDIR)$(PREFIX)/lib/systemd/system
 SYSCONFDIR := $(DESTDIR)/etc/default
-BUILDTAGS := 'apparmor seccomp containers_image_ostree_stub exclude_graphdriver_btrfs exclude_graphdriver_devicemapper'
+BUILDTAGS := 'apparmor seccomp containers_image_ostree_stub exclude_graphdriver_btrfs exclude_graphdriver_devicemapper containers_image_openpgp'
 GO_MD2MAN := /usr/bin/go-md2man
 
 define CRIO_CONF_OVERRIDE
@@ -19,14 +19,14 @@
 endef
 export CRIO_CONF_OVERRIDE
 
-ifneq (,$(wildcard /usr/lib/go-1.18/bin/go))
-        GO_BINARY := /usr/lib/go-1.18/bin/go
+ifneq (,$(wildcard /usr/lib/go-1.19/bin/go))
+        GO_BINARY := /usr/lib/go-1.19/bin/go
 else
         GO_BINARY := /usr/bin/go
 endif
 GO := GOPATH=$(BUILDDIR) GO111MODULE=off $(GO_BINARY)
 GO_BUILD := "$(GO) build"
-UPSTREAM_TAG=v1.24.6
+UPSTREAM_TAG=v1.25.0
 
 %:
 	dh_clean
